﻿Public Class Form1

    'Singleton: récupère une instance de la classe ThreadManager
    Private myThreadManager As ThreadManager = ThreadManager.GetInstance

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Nombre de thread maximum à utilisé (3 + le thread principal qui gère la distribution des taches)
        myThreadManager.MaxThread = 3

        'Ajoute 18 "taches" afin de tester le manager de thread
        For inc As Integer = 0 To 17
            myThreadManager.Add(AddressOf test, True)
        Next

        'Le timer sert juste à indiquer l'état du manager de thread
        Timer1.Enabled = True
        myThreadManager.Start()
    End Sub

    'fonction faisant perdre du temps histoire de voir le manager travailler
    Private Sub test()
        Dim a As Integer
        Do While a <= (Integer.MaxValue / 8)
            a += 1
        Loop
    End Sub

    'remplie les labels afin de voir visuellement ce qui passe
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Label2.Text = ThreadManager.GetInstance.TaskCounts
        Label5.Text = ThreadManager.GetInstance.TaskCount
        Label3.Text = ThreadManager.GetInstance.ThreadRun

        If ThreadManager.GetInstance.HaveTask = False Then
            Timer1.Enabled = False
            MsgBox("travail terminé")
            Application.Exit()
        End If
    End Sub

    'ne pas oublier d'appeler le destructeur du manager de thread afin de bien arréter
    'les threads encore actifs
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        myThreadManager.Dispose()
    End Sub
End Class
